<?php
/**
*	@version	0.1.0
*	@author		Ruud Eisinga (Ruud)
*	@date		2008-08-20
*	@state		@dev
*
*	Displays the number of users online.
*
*/

function UsersOnline ($use_tooltip = 1, $prefix = "Currently: " , $suffix = " users online.", $single = " user online.", $admin_ip = "127.0.0.1") {
	global $database, $wb;
	$page_title = PAGE_TITLE;
	$page = $_SERVER['REQUEST_URI'];
	$ipaddress = $_SERVER['REMOTE_ADDR'];
	$useragent = $_SERVER['HTTP_USER_AGENT'];
	$userlist = "";
	$timestamp = time(); 
	$timeout = $timestamp - 300; //timeout on 5 minutes

	$table = TABLE_PREFIX ."mod_usercounter";
	$check = $database->query("SELECT ip FROM $table where ip = '$ipaddress'");  // Check if is existing
	if ( $check->numRows() == 0 )
	  $database->query("INSERT INTO $table (`timestamp`,`ip`,`page`,`page_title`,`user_agent`) VALUES ('$timestamp','$ipaddress','$page','$page_title','$useragent')");  // Add new IP
	else
	  $database->query("UPDATE $table SET `timestamp`='$timestamp',`page`='$page',`page_title`='$page_title', `user_agent`= '$useragent' WHERE ip = '$ipaddress'");  // Update existing
		
	$database->query("DELETE FROM $table WHERE timestamp < $timeout");  // Delete hits older than 5 mintes
	$counter_res = $database->query("SELECT * FROM $table order by 'timestamp'");  // Get records for counting, one record per IP
    $user = $counter_res->numRows();  // Number of records is number of users
	
	if ($use_tooltip != 0) {
		while($res = $counter_res->fetchRow()) {
			if ($admin_ip == $ipaddress) 
				$userlist .= date("H:i:s",$res['timestamp'])." [".$res['ip']."] ".$res['page']." (".$res['page_title'].") ".bot($res['user_agent'])."<br/>";
			else
				$userlist .= date("H:i:s",$res['timestamp'])." - ".$res['page']." (".$res['page_title'].")<br/>";
		}
		echo '<SCRIPT language="JavaScript1.2" src="'.WB_URL.'/modules/usersonline/overlib_mini.js" type="text/javascript"></SCRIPT>';
		echo "<span href=\"javascript:void(0);\" onmouseover=\"return overlib('$userlist',HAUTO,VAUTO,WIDTH,600,BGCOLOR,'#FFFFFF',FGCOLOR,'#FFFFFF',BORDER,5,WRAP);\" onmouseout=\"return nd();\">";
	}
	if($user == 1) { 
		echo $prefix.$user.$single;
	} else { 
		echo $prefix.$user.$suffix;
	}
	if ($use_tooltip != 0)
		echo "</span>";	
}

Function bot($agent) {
	   
	   $botlist = array(   
                "Firefox",                   
                "MSIE 7",                   
                "MSIE 6",                   
                "Opera",                   
                "Internet Explorer",                   
                "Teoma",                   
                "alexa",
                "froogle",
                "inktomi",
                "looksmart",
                "URL_Spider_SQL",
                "Firefly",
                "NationalDirectory",
                "Ask Jeeves",
                "TECNOSEEK",
                "InfoSeek",
                "WebFindBot",
                "girafabot",
                "crawler",
                "www.galaxy.com",
                "Googlebot",
                "googlebot",
                "Scooter",
                "Slurp",
                "appie",
                "FAST",
                "WebBug",
                "Spade",
                "ZyBorg",
                "rabaz");

    foreach($botlist as $bot) {

      if(ereg($bot, $agent)) {

          if($bot == "Googlebot") {
            if (substr($REMOTE_HOST, 0, 11) == "216.239.46.") $bot = "Googlebot Deep Crawl";
            elseif (substr($REMOTE_HOST, 0,7) == "64.68.8") $bot = "Google Freshbot";
          }
          return " - ".$bot;
      }
    }

	return " - ".$agent;
	
}

?>
